; ====================================================
;             PureFILE library V1 - test file 1
; ====================================================
;
;
; Read lines from file
;
tick = GetTickCount_()
If PureFILE_ReadFile(#PB_Any, "C:\PureBasic393\Compilers\APIFunctionListing.txt")
  While PureFILE_NotEof()
    PureFILE_ReadString()
  Wend
  PureFILE_CloseFile()
EndIf
Debug StrF((GetTickCount_() - tick) / 1000)
Beep_(2000, 500)
;
; Read lines from file (faster)
;
tick = GetTickCount_()
If PureFILE_ReadTextFile(#PB_Any, "C:\PureBasic393\Program\bigtextfile.txt") ; 3.5 Mb, 114976 lines
  Debug "Counting lines..."
  ;Debug PureFILE_CountLines()
  Debug "Reading..."
  While PureFILE_NotEof()
    Line.s = PureFILE_ReadString()
  Wend
  PureFILE_CloseFile()
  Debug Line
EndIf
Debug StrF((GetTickCount_() - tick) / 1000)
Beep_(2000, 500)
;
; Copy file
;
If PureFILE_ReadFile(1, "C:\PureBasic393\Compilers\APIFunctionListing.txt")
  If PureFILE_CreateFile(2, "C:\PureBasic393\Compilers\APIFunctionListing2.txt")
    *Buffer = AllocateMemory(50000)
    If *Buffer
      BytesRead = PureFILE_ReadData(1, *Buffer, 50000)
      While BytesRead
        BytesWritten = PureFILE_WriteData(2, *Buffer, BytesRead)
        BytesRead = PureFILE_ReadData(1, *Buffer, 50000)
      Wend
      PureFILE_CloseFile(1)
      PureFILE_CloseFile(2)
      FreeMemory(*Buffer)
    EndIf
  EndIf
EndIf
;
; Read/write in text files
;
File.s = "Hello.txt"
If PureFILE_CreateFile(#PB_Any, File)
  PureFILE_WriteString("PureFILE ")
  PureFILE_WriteStringN("library test")
  PureFILE_WriteStringN("Line 2")
  PureFILE_WriteStringN("Line 3")
  PureFILE_CloseFile()
EndIf
Debug "-------- 1 --------"
If PureFILE_ReadFile(#PB_Any, File)
  While PureFILE_NotEof()
    Debug PureFILE_ReadString()
  Wend
  PureFILE_CloseFile()
EndIf
;
; Read/write in binary files
;
File.s = "Hello.bin"
If PureFILE_CreateFile(1, File)
  PureFILE_WriteLong(1, 'lleh')
  PureFILE_WriteWord(1, ' o')
  PureFILE_WriteByte(1, '!')
  PureFILE_CloseFile(1)
EndIf
Debug "-------- 2 --------"
If PureFILE_ReadFile(#PB_Any, File)
  While PureFILE_NotEof()
    Debug Chr(PureFILE_ReadByte())
  Wend
  PureFILE_CloseFile()
EndIf
Debug "-------- 3 --------"
If PureFILE_ReadFile(10, File)
  Debug Hex(PureFILE_ReadByte(10))
  Debug Hex(PureFILE_ReadWord(10))
  Debug Hex(PureFILE_ReadLong(10))
  PureFILE_CloseFile(10)
EndIf
;
; Create a link
;
LinkFileName.s = "c:\Purebasic.lnk"
FileLinkedTo.s = "C:\PureBasic393\jaPBe\jaPBe.exe"
Arguments.s = ""
Description.s = "Purebasic IDE"
WorkingDirectory.s = "c:\purebasic393"
ShowCommand.l = #SW_SHOWNORMAL
IconFile.s = FileLinkedTo
IconIndexInFile.l = 0
PureFILE_CreateLink(LinkFileName, FileLinkedTo, Arguments, Description, WorkingDirectory, ShowCommand, HotKey, IconFile, IconIndexInFile)
;
; File attributes
;
Debug FormatDate("%dd/%mm/%yyyy %hh:%ii:%ss", PureFILE_GetDate("C:\PureBasic393\jaPBe\jaPBe.exe"))
Debug PureFILE_GetAttributes("C:\PureBasic393\jaPBe\jaPBe.exe") & #File_Attribute_Hidden
PureFILE_AddAttributes("C:\PureBasic393\jaPBe\jaPBe.exe", #File_Attribute_Hidden)
Debug PureFILE_GetAttributes("C:\PureBasic393\jaPBe\jaPBe.exe") & #File_Attribute_Hidden
PureFILE_RemoveAttributes("C:\PureBasic393\jaPBe\jaPBe.exe", #File_Attribute_Hidden)
